import ftcomputing.roboTX.*;
/**
 * Einfacher Personenaufzug www.ftcomputing.de/persaufzug.htm
 * 
 * @author Ulrich Mller 
 * @version 02.01.10
 */
public class PersonenAufzug 
{
    FishFaceTX tx = new FishFaceTX();
    final Mot Aufzug = Mot.M1;
    final Out LampeO = Out.O5;
    final Out LampeU = Out.O7;
    final Unv EndeO  = Unv.I1;
    final Unv EndeU  = Unv.I2;
    final Unv AnfO   = Unv.I3;
    final Unv AnfU   = Unv.I4;

    public static void main() {
        PersonenAufzug pa = new PersonenAufzug();
        System.out.println("PersonenAufzug gestartet");
        System.out.println("FishFace-Version : " + FishFaceTX.Version());
        try { pa.Action(); }
        catch(FishFaceException eft) { System.out.println(eft);}
        finally { System.out.println("Finito"); }

    }
    private void Action() {
        tx.openController("COM4");
        do {
            Runter();
            while(!tx.getInput(AnfO) && !tx.getInput(AnfU) && 
                  !tx.finish()) tx.pause(123);
            Hoch();
            while(!tx.getInput(AnfO) && !tx.getInput(AnfU) && 
                  !tx.finish()) tx.pause(123);
        } while(!tx.finish());    
        tx.closeController();
    }
    
    private void Runter() {
        System.out.println("Fhrt");
        tx.setLamp(LampeO, 0);
        tx.setMotor(Aufzug, Dir.Right);
        tx.waitForInput(EndeU, true);
        tx.setMotor(Aufzug, Dir.Off);
        tx.setLamp(LampeU, 512);
        System.out.println("Unten");
    }
    private void Hoch() {
        System.out.println("Fhrt");
        tx.setLamp(LampeU, 0);
        tx.setMotor(Aufzug, Dir.Left);
        tx.waitForInput(EndeO, true);
        tx.setMotor(Aufzug, Dir.Off);
        tx.setLamp(LampeO, 512);
        System.out.println("Oben");
    }
}
