import ftcomputing.roboTX.*;
/**
 * Einfhrung in die Programmierung der Industry Robot mit 
 * ftcomputing.roboTX.jar : FishFace
 * 
 * Sulenrobot nach Industry Robot II mit der dort angegebenen Interface-Belegung
 * Sule M1, Endtaster I1, Impulstaster C1, 
 * Arm waagerecht M2, I2, C2, Arm senkrecht M3, I3, C3
 * Greifer M4, I4, C4, alternative Lampe
 * Die Robotkomponenten mssen bei Linkslauf auf den zugehrenden Endtaster drehen.
 * 
 * @author Ulrich Mller 
 * @version 16.03.10
 */
public class RobTXtut {
    private FishFaceTX tx;
    private int[] actPos = new int[4];
    /**
     * Konstruktor mit OpenInterface an erstem Robo Interface an USB
     */
    public RobTXtut() {
        tx = new FishFaceTX();
        tx.openController("COM4");
    }

    /**
     * Sule mit Motor an M1 luft links bis Endtaster an I1
     */
    public void goHome() {
        System.out.println("Motor M1 Home, wartet auf I1");
        tx.setMotor(Mot.M1, Dir.Left);
        tx.waitForInput(Unv.I1, true);
        tx.setMotor(Mot.M1, Dir.Off);
        System.out.println("--- Zu Hause ---");
    }
    
    /**
     * Fahren Sule um Anzahl Impulse nach rechts
     */
    public void goRight(int Inc) {
        System.out.println("Sule dreht rechts um : " + Inc);
        tx.startRobMotor(Mot.M1, Dir.Right, 512, Inc);
        tx.waitForMotors(Mot.M1);
        System.out.println("--- Sule angekommen ---");
    }   
}
