// -------------------------------------------------------------------------------
//
// HanoiTower                                            Ulrich Mller    16.04.10
//                                                       Aspire Java 6 Eclipse 3.4
// Turm von Hanoi : Lsung mit Robo TX Controller und FishFaceTX
//
// -------------------------------------------------------------------------------
import ftcomputing.roboTX.*;
public class HanoiTower {
	HanoiRobot hr;
	public static void main(String[] args) {
		HanoiTower ht = new HanoiTower();
		ht.action();
	}
	private void action() {
		hr = new HanoiRobot();
		System.out.println("HanoiTower wird gestartet");
		hr.openController("COM4");
		System.out.println("Fhrt auf Grundstellung");
		hr.grundstellung();
		System.out.println("Bei der Arbeit");
		hanoi(3, 2, 22, 38);
		System.out.println("--- FINIS ---");
		hr.closeController();
	}
	private void hanoi(int n, int pAnf, int pMit, int pEnd) {
		if(n == 1) {
			System.out.println("Scheibe " + n + " : von " + pAnf + " nach " + pEnd);
			hr.ziehe(pAnf, pEnd);
		}
		else {
			hanoi(n-1, pAnf, pEnd, pMit);
			System.out.println("Scheibe " + n + " : von " + pAnf + " nach " + pEnd);
			hr.ziehe(pAnf, pEnd);
			hanoi(n-1, pMit, pAnf, pEnd);
		}
	}
	private class HanoiRobot extends FishFaceTX {
		private final int PowerFull = 512;
		private final int PowerOff  = 0;
		private final Mot mSaule    = Mot.M1;
		private final Mot mArm      = Mot.M2;
		private final Unv iArmOben  = Unv.I3;
		private final Unv iArmUnten = Unv.I4;
		private final Out mGreifer  = Out.O5;
		private int robPos;
		
		public void grundstellung(){
			setLamp(mGreifer, PowerOff);
			armHeben();
			robPos = 9999;
			sauleNach(0);
		}
		public void ziehe(int von, int nach) {
			sauleNach(von);
			armSenken();
			setLamp(mGreifer, PowerFull);
			armHeben();
			sauleNach(nach);
			armSenken();
			setLamp(mGreifer, PowerOff);
			armHeben();
		}
		private void sauleNach(int zielPos){
			if(robPos < zielPos) {
				startRobMotor(mSaule, Dir.Right, PowerFull, zielPos-robPos);
				robPos = zielPos + waitForMotor(mSaule);
			}
			else {
				startRobMotor(mSaule, Dir.Left, PowerFull, robPos-zielPos);
				robPos = zielPos - waitForMotor(mSaule);
			}
		}
		private void armSenken() {
			setMotor(mArm, Dir.Left);
			waitForInput(iArmUnten, true);
			setMotor(mArm, Dir.Off);
		}
		private void armHeben() {
			setMotor(mArm, Dir.Right);
			waitForInput(iArmOben, true);
			setMotor(mArm, Dir.Off);
		}
	}
}
